#ifndef __HD_HELPER_H__
#define __HD_HELPER_H__

#include <HD/hd.h>
#include <HDU/hdu.h>
#include <HDU/hduError.h>
#include <HDU/hduVector.h>

typedef struct
{
	int button1;
	int button2;

    hduVector3Dd position;
    hduVector3Dd force;
    HDdouble transform[16];

    hduVector3Dd userForce;
    HDboolean isUserForceActive;

    hduVector3Dd anchor;
    HDboolean isAnchorActive;
} HapticDisplayState;

extern HapticDisplayState deviceState;
extern int activeAtom;
extern float atomRadius;

HDCallbackCode HDCALLBACK copyHapticDisplayState(void *pUserData);
HDCallbackCode HDCALLBACK setHapticUserForce(void *pUserData);
HDCallbackCode HDCALLBACK resetHapticUserForce(void *pUserData);
HDCallbackCode HDCALLBACK setHapticAnchor(void *pUserData);
HDCallbackCode HDCALLBACK resetHapticAnchor(void *pUserData);

void getModelCoord(t_coord *res, hduVector3Dd vec);
void getHapticCoord(hduVector3Dd res, t_coord vec);

void drawCursor(const HapticDisplayState *pState);
void updateWorkspace();

void initHD();
void exitHandler(void);
#endif
